[![Gitter](https://badges.gitter.im/DroidGame/DroidGame3D.svg)](https://gitter.im/DroidGame/DroidGame3D?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge)

[original readme](https://gitlab.com/polskiychel/droidgame3d/-/blob/main/README.md)
[itch.io страница](https://ma3rx.itch.io/droid-game-3d)

![image](https://gitlab.com/polskiychel/droidgame3d/-/raw/main/logo.png)
# Droid Game 3D

Это свежая игра, которая была разработана на игровом движке **Panda3D** и языке **Python** в IDE **PyCharm**(не знаю, зачем вам эта информация).
На данный момент игра имеет достаточно большую аудиторию и большой ежедневный онлайн(1000+ игроков стабильно). В общем, вроде больше ничего примечательного тут нету, время начинать наше путешествие...

# Установка
## Linux 
В операционной системе **Linux** все просто: вначале устанавливаем все пакеты `pip install -r ./requirements.txt`, пишем в терминал `git clone https://github.com/WennMarcoRTX/droidgame3d.git`, потом `cd droidgame3d`, пишем если у вас есть Cython, то `cython ./game.pyx`, а если просто Python, то `python3 ./game.py`, если у вас C, то `c ./game.c`(сборку под Go, Ruby и C++ выпустим скоро, ждите ;) ). 
## Windows
Для **Windows** у нас есть отдельная сборка с *.exe* и *.dll* файлами, которые всегда прилагаются при выпуске новой версии, но если вы хотите играть в игру с исходным кодом, то установка у вас такая же, как у **Linux**, поздравляю.

# Управление
Тут представлено полное управление для нашей игры. 
## В меню:
В любом меню нашей игры, где бы вы не были, от выбора сервера до чата, везде кнопка **Esc** закрывает это меню. Если вы находитесь в главном меню - **Esc** закрывает и его, и игра заканчивается. 
## В игре:
*Примечание: скачки по типу **вперед+влево** возможны.*

**Esc** - выход в главное меню.

**Стрелка влево** - поворот дроида влево.

**Стрелка вправо** - поворот дроида вправо.

**Стрелка вперед** - движение дроида вперед.

**A** - сдвиг фокуса камеры относительно дроида влево.

**D** - сдвиг фокуса камеры относительно дроида вправо.

**Пробел** - выстрел.

**S** - достать фонарик(если вы уже его достали, кнопка **S** будет его включать и выключать).

**W** - убрать оружие.

**P** - показать прицел(если уже показан - убрать).

**G** - кинуть гранату.

**F** - начать двигать корабль.

**0** - в случае пожара. Тушит пожар.

**F3** - только если одиночная игра, включает полигональный режим.

**R** - включает и выключает RPG режим.


# Оптимизация
Наша игра уже была переписана на **C** и на **Cython**. Сейчас мы переписываем ее на **Go** и **Ruby**.
Однако, для всех версий мы используем дополнительную оптимизацию:

1. Использование JIT-компиляторов **Numba** и **Pyjion**.
2. Многопоточность.
3. Мультипроцессинг(отдельные процессы, которые передают информацию через вашу оперативную память).
4. AsyncIO.
5. Поддержка CUDA(работа всего кода на GPU).

